//+------------------------------------------------------------------+
//|                                                      .mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property version   "1.00"           //                
                                     //       ,    _    
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  Blue
#property indicator_color2  Red                                   
#property indicator_width1  1
#property indicator_width2  1
//----
extern int PERIOD = 15;
//---- buffers 

double  buf_up[], buf_dn[], buf_sum[],ExtMapBuffer1[],ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit(void)     
//--- indicator buffers mapping  
  {
  SetIndexBuffer(0, ExtMapBuffer1);
  SetIndexBuffer(1, ExtMapBuffer2);
  SetIndexBuffer(2, buf_sum);
  SetIndexBuffer(3, buf_dn);
  SetIndexBuffer(4, buf_up);      
  SetIndexStyle(0,DRAW_ARROW);
  SetIndexArrow(0,233);
  SetIndexStyle(1,DRAW_ARROW);
  SetIndexArrow(1,234);
  SetIndexEmptyValue(0,0.0);
  SetIndexEmptyValue(1,0.0);
  SetIndexEmptyValue(2, -1);
  SetIndexEmptyValue(3, -1);
  SetIndexEmptyValue(4, -1);       
  SetIndexLabel(0, "BAY");     
  SetIndexLabel(1, "SELL");
  IndicatorShortName(" ("+DoubleToStr(PERIOD,0)+")");
  if(PERIOD<=0)
     {
      Print("Wrong input parameter PERIOD=",PERIOD);
      return(INIT_FAILED);
     }
  IndicatorDigits(Digits); 
//--   
   return(INIT_SUCCEEDED);  
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+      
    int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])        
   {
   int    i ,limit=rates_total-prev_calculated;  
   if(rates_total<=PERIOD || PERIOD<=0)
      return(0);   
   if(prev_calculated==0)limit--;
   else  limit++;
   double  u=0, d=0, sum=0 ;  
   for( i=0; i<limit && !IsStopped(); i++)    
   {
   d = iCustom(NULL, 0,"", PERIOD, 0, i) ; 
   buf_dn[i]  = d *Low[i];                      
   u = iCustom(NULL, 0,"", PERIOD, 0, i) ; 
   buf_up[i]  = u * High[i] ;                   
   sum = ((u + d )*( High[i] + Low[i] )) / 2;
   buf_sum[i]  = sum ;  
  if(buf_sum[i]>buf_sum[i-1]&&buf_sum[i]>buf_sum[i+1]&&buf_sum[i]>buf_up[i]&&buf_sum[i]>0)
  {
  ExtMapBuffer2[i]= High[i]+buf_dn[i]/MathAbs(buf_up[i]-buf_dn[i])*(High[i]-Low[i]) ; 
  }
  if(buf_sum[i]<0&& buf_sum[i]<buf_sum[i+1]&&buf_sum[i]<buf_dn[i]&&buf_sum[i]<buf_sum[i-1] )
  {
  ExtMapBuffer1[i]= Low[i]- MathAbs(buf_up[i])/(MathAbs(buf_dn[i])-MathAbs(buf_up[i]))*(High[i]-Low[i]);  
  }       
  }
   return(rates_total);
  }
//+-------------------------------------------------------------------------------------------------------+